//---------------------------------------------------------------------------

#ifndef SimpleUDSH
#define SimpleUDSH
//---------------------------------------------------------------------------
#include <Classes.hpp>
#include <Controls.hpp>
#include <StdCtrls.hpp>
#include <Forms.hpp>
#include <ExtCtrls.hpp>
#include <ScktComp.hpp>
//---------------------------------------------------------------------------
class TForm1 : public TForm
{
__published:	// IDE-managed Components
        TMemo *TrafficMemo;
        TLabel *Label1;
        TServerSocket *SckServer;
        TTimer *Timer1;
        TLabeledEdit *PortEdit;
        TCheckBox *ShowFlow;
        TRadioGroup *PollPush;
        TGroupBox *GroupBox1;
        TCheckBox *UDSCheckBox1;
        TCheckBox *UDSCheckBox2;
        TCheckBox *UDSCheckBox3;
        TCheckBox *UDSCheckBox4;
        TCheckBox *UDSCheckBox5;
        TCheckBox *UDSCheckBox6;
        TCheckBox *UDSCheckBox7;
        TCheckBox *UDSCheckBox8;
        TEdit *CH1Edit;
        TEdit *CH2Edit;
        TEdit *CH3Edit;
        TEdit *CH4Edit;
        TEdit *CH5Edit;
        TEdit *CH6Edit;
        TEdit *CH7Edit;
        TEdit *CH8Edit;
        TButton *Button1;
        void __fastcall SckServerAccept(TObject *Sender,
                TCustomWinSocket *Socket);
        void __fastcall SckServerClientConnect(TObject *Sender,
                TCustomWinSocket *Socket);
        void __fastcall SckServerGetSocket(TObject *Sender, int Socket,
                TServerClientWinSocket *&ClientSocket);
        void __fastcall SckServerListen(TObject *Sender,
                TCustomWinSocket *Socket);
        void __fastcall SckServerClientRead(TObject *Sender,
                TCustomWinSocket *Socket);
        void __fastcall SckServerClientWrite(TObject *Sender,
                TCustomWinSocket *Socket);
        void __fastcall SckServerGetThread(TObject *Sender,
                TServerClientWinSocket *ClientSocket,
                TServerClientThread *&SocketThread);
        void __fastcall SckServerThreadEnd(TObject *Sender,
                TServerClientThread *Thread);
        void __fastcall SckServerThreadStart(TObject *Sender,
                TServerClientThread *Thread);
        void __fastcall Timer1Timer(TObject *Sender);
        void __fastcall SckServerClientError(TObject *Sender,
          TCustomWinSocket *Socket, TErrorEvent ErrorEvent,
          int &ErrorCode);
        void __fastcall Button1Click(TObject *Sender);
        void __fastcall PollPushClick(TObject *Sender);

private:	// User declarations
        void __fastcall TForm1::ProcesClientMessages(AnsiString MsgBuff,TCustomWinSocket *Socket);
        int __fastcall TForm1::CountChan();
        void __fastcall TForm1::SendData(TCustomWinSocket *Socket);
public:		// User declarations
        __fastcall TForm1(TComponent* Owner);
};
//---------------------------------------------------------------------------
extern PACKAGE TForm1 *Form1;
//---------------------------------------------------------------------------
#endif
