VERSION 5.00
Object = "{33101C00-75C3-11CF-A8A0-444553540000}#1.0#0"; "cswsk32.ocx"
Begin VB.Form UDSForm 
   Caption         =   "User Data Source"
   ClientHeight    =   3615
   ClientLeft      =   60
   ClientTop       =   345
   ClientWidth     =   4680
   LinkTopic       =   "Form1"
   ScaleHeight     =   3615
   ScaleWidth      =   4680
   StartUpPosition =   3  'Windows Default
   Begin SocketWrenchCtrl.Socket Socket1 
      Index           =   0
      Left            =   3600
      Top             =   1290
      _Version        =   65536
      _ExtentX        =   741
      _ExtentY        =   741
      _StockProps     =   0
      AutoResolve     =   -1  'True
      Backlog         =   5
      Binary          =   -1  'True
      Blocking        =   0   'False
      Broadcast       =   0   'False
      BufferSize      =   1024
      HostAddress     =   ""
      HostFile        =   ""
      HostName        =   ""
      InLine          =   0   'False
      Interval        =   0
      KeepAlive       =   0   'False
      Library         =   ""
      Linger          =   0
      LocalPort       =   0
      LocalService    =   ""
      Protocol        =   0
      RemotePort      =   0
      RemoteService   =   ""
      ReuseAddress    =   0   'False
      Route           =   -1  'True
      Timeout         =   0
      Type            =   1
      Urgent          =   0   'False
   End
   Begin VB.TextBox txtTZ 
      Height          =   285
      Left            =   1230
      TabIndex        =   16
      Text            =   "0"
      Top             =   960
      Width           =   735
   End
   Begin VB.TextBox txtPrinterPort 
      Height          =   285
      Left            =   1860
      TabIndex        =   13
      Text            =   "1"
      Top             =   1740
      Width           =   435
   End
   Begin VB.OptionButton Option2 
      Caption         =   "ADC12"
      Height          =   315
      Left            =   1410
      TabIndex        =   11
      Top             =   1290
      Value           =   -1  'True
      Width           =   945
   End
   Begin VB.OptionButton Option1 
      Caption         =   "ADC10"
      Height          =   345
      Left            =   330
      TabIndex        =   10
      Top             =   1290
      Width           =   915
   End
   Begin VB.CommandButton cmdDisconnect 
      Caption         =   "&Disconnect"
      Height          =   345
      Left            =   210
      TabIndex        =   9
      ToolTipText     =   "Manually disconnects from SkyPipe"
      Top             =   2640
      Width           =   1125
   End
   Begin VB.CommandButton cmdApply 
      Caption         =   "&Apply"
      Height          =   315
      Left            =   3360
      TabIndex        =   8
      ToolTipText     =   "Apply changes to parameter fields."
      Top             =   2730
      Width           =   1185
   End
   Begin VB.CommandButton cmdSave 
      Caption         =   "&Save Defaults"
      Height          =   345
      Left            =   3360
      TabIndex        =   7
      ToolTipText     =   "Save the displayed parameters as the defaults."
      Top             =   2340
      Width           =   1185
   End
   Begin VB.CommandButton cmdGetDefaults 
      Caption         =   "&Get Defaults"
      Height          =   345
      Left            =   3360
      TabIndex        =   6
      ToolTipText     =   "Load defaults from the registry."
      Top             =   1950
      Width           =   1185
   End
   Begin VB.CheckBox chkTimeStamps 
      Caption         =   "Generate Time Stamps in UDS"
      Height          =   285
      Left            =   270
      TabIndex        =   5
      Top             =   2100
      Width           =   2595
   End
   Begin VB.Timer Timer1 
      Enabled         =   0   'False
      Interval        =   100
      Left            =   4110
      Top             =   1170
   End
   Begin VB.TextBox txtPort 
      Height          =   285
      Left            =   1230
      TabIndex        =   2
      Text            =   "1337"
      Top             =   600
      Width           =   735
   End
   Begin VB.TextBox txtIP 
      Height          =   315
      Left            =   1230
      TabIndex        =   0
      Text            =   "127.0.0.1"
      Top             =   210
      Width           =   1125
   End
   Begin VB.Label Label6 
      Caption         =   "Time Zone"
      Height          =   225
      Left            =   150
      TabIndex        =   17
      Top             =   990
      Width           =   1065
   End
   Begin VB.Label Label5 
      Caption         =   "Use this UDS in Poll mode only."
      Height          =   435
      Left            =   1500
      TabIndex        =   15
      Top             =   2550
      Width           =   1665
   End
   Begin VB.Label Label4 
      Caption         =   "Printer Port Number"
      Height          =   255
      Left            =   270
      TabIndex        =   14
      Top             =   1740
      Width           =   1515
   End
   Begin VB.Label Label3 
      Caption         =   "PICO UDS for Radio-SkyPipe"
      BeginProperty Font 
         Name            =   "Arial"
         Size            =   9.75
         Charset         =   0
         Weight          =   700
         Underline       =   0   'False
         Italic          =   0   'False
         Strikethrough   =   0   'False
      EndProperty
      ForeColor       =   &H00000080&
      Height          =   495
      Left            =   2640
      TabIndex        =   12
      Top             =   150
      Width           =   1965
   End
   Begin VB.Label LBLstatus 
      BorderStyle     =   1  'Fixed Single
      Height          =   315
      Left            =   150
      TabIndex        =   4
      Top             =   3120
      Width           =   4395
   End
   Begin VB.Label Label2 
      Caption         =   "Port"
      Height          =   255
      Left            =   480
      TabIndex        =   3
      Top             =   630
      Width           =   645
   End
   Begin VB.Label Label1 
      Caption         =   "IP Address"
      Height          =   255
      Left            =   300
      TabIndex        =   1
      Top             =   240
      Width           =   885
   End
End
Attribute VB_Name = "UDSForm"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
Dim TZ As Double
Dim PortNum As Integer
Dim Product As Integer
Dim NumChannels 'number of Channels you will be using
Dim UDSip As String 'IP address
Dim UDSport As Integer ' Port number
Dim GenerateTimeStamps As Boolean
Sub SendMsgToSkyPipe(M$)
On Error Resume Next
'M$ is a string  message you want to pass to SkyPipe
'use this to send a text message to SkyPipe
'The message is passed to the same routine in  SkyPipe that processes messages
'from the Message Manager program.

'Excluding Message Appearances

'By default the messages transferred by Message Manager go to all of the destinations
'listed below. You can however exclude any of these destinations by attaching
'a prefix to the message.  The prefix contains one or more single letter flags shown below
'followed by two % signs (%%) followed by the message.

'  S - exclude from Session Log
'  C - exclude from Chat
'  I - exclude from data file header notes
'  L - exclude from the status bar
'  O - exclude from the observers log

'For example, to exclude the message from the Session log and Chat the message
'would be prefixed with:  SC%%

Dim buf As String
If Socket1.Count = 2 Then
        If Socket1(1).Connected Then
                buf = "^^1002" + M$ + Chr(255)
                Socket1(1).Write buf, Len(buf)
                DoEvents
        End If
End If

End Sub

Sub UDSInit()
'initialize anything you need to before collecting and sending data to SkyPipe
' for example, if you are generating your own timestamps in the UDS
' and you are using the CalcTime routine, this might be a good place to set
' the UToffset variable:

'Calculate UToffset with:     UToffset = -1 * (TZ / 24)
' were TZ is your timezone in hours from GMT
' if TZ was -10 then

UToffset = -1 * (TZ / 24)


End Sub
Sub PushDataInit()
'this is where you would put a routine if you needed to do anything in
'preparation for pushing data to SkyPipe

'in this example  we are going to turn on a timer which push the data
Timer1.Interval = 100 'set the interval 100ms
Timer1.enabled = True


End Sub
Sub PollDataInit()
'this is where you would put a routine if you needed to do anything in
'preparation for polling of data from SkyPipe
End Sub
Sub GetParamsFromDisplay()
On Error Resume Next
If Socket1.Count = 2 Then 'make sure the second socket exists before trying to get rid of it
            If Socket1(1).Connected Then
                    Socket1(1).Disconnect
            Else
                    Socket1(1).Cleanup
                    Unload Socket1(1)
            End If
End If
TZ = Val(txtTZ)
UToffset = -1 * (TZ / 24)
UDSip = txtIP
UDSport = txtPort
If chkTimeStamps.Value = 1 Then GenerateTimeStamps = True Else GenerateTimeStamps = False
adc10_close_unit PortNum
PortNum = Val(txtPrinterPort)
If Option1.Value = True Then Product = 10
If Option2.Value = True Then Product = 12
adc10_open_unit PortNum, Product

'socket1(0) is the socket that the connection request arrives on from SkyPipe
'Upon receiving a connection request it will pass the connection to socket1(1) via the request id
Socket1(0).Cleanup
Socket1(0).Bind UDSip, UDSport
Socket1(0).Listen

End Sub

Sub SaveDefaults()
SaveSetting App.Title, "Settings", "IP", UDSip
SaveSetting App.Title, "Settings", "Port", Str$(UDSport)
If GenerateTimeStamps Then
        SaveSetting App.Title, "Settings", "GenerateTimeStamps", "True"
Else
        SaveSetting App.Title, "Settings", "GenerateTimeStamps", "False"
End If
SaveSetting App.Title, "Settings", "TZ", Str$(TZ)
SaveSetting App.Title, "Settings", "PrinterPortNum", Str$(PrinterPortNum)
SaveSetting App.Title, "Settings", "Product", Str$(Product)
End Sub
Sub LoadDefaults()
Dim T As String
'get the defaults from the registry
UDSip = GetSetting(App.Title, "Settings", "IP", "127.0.0.1")
UDSport = Val(GetSetting(App.Title, "Settings", "Port", "1377"))
T = GetSetting(App.Title, "Settings", "GenerateTimeStamps", "False")
If T = "False" Then
        GenerateTimeStamps = False
Else
        GenerateTimeStamps = True
End If
NumChannels = 1
TZ = Val(GetSetting(App.Title, "Settings", "TZ", "1"))
PortNum = Val(GetSetting(App.Title, "Settings", "PrinterPortNum", "1"))
Product = Val(GetSetting(App.Title, "Settings", "Product", "12"))
UpdateOptionsDisplay 'show options

End Sub
Sub GetSendData()
'This is routine where data is pulled from your ADC or whatever source and sent to SkyPipe
'we use this routine when data is being POLLED by SkyPipe
On Error Resume Next
Dim buf As String ' used to write data to SkyPipe
Dim TS As Double 'Timestamps are doubles
Dim D As Integer 'just a value used here to hold the phoney data we are sending
Static U As Integer 'dummy data variable...get rid of it in your routine where you have real data
Dim PicoVal As Integer
If Socket1.Count < 2 Or Socket1(1).Connected = False Then Exit Sub ' don't try to send data if not connected

PicoVal = adc10_get_value
buf = "#0" + Str(PicoVal) + Chr(255)
Socket1(1).Write buf, Len(buf)
'data is not updated in the strip chart until one of the following codes (3000 or 3001) is sent to SkyPipe
'3000 is used if you are generating your own timestamps here in the UDS
'3001 tells SkyPipe to generate the timestamp for you when it receives this message
'Note that data from all channels is sent before the timestamp is sent

If GenerateTimeStamps Then
        TS = GetTimeStamp ' call your routine to generate a timestamp
        buf = "^^3000" + Str$(TS) + Chr(255)
        Socket1(1).Write buf, Len(buf)
Else
        'let SkyPipe genrate the timestamp
        buf = "^^3001" + Chr(255)
        Socket1(1).Write buf, Len(buf)
End If

End Sub
Function GetTimeStamp() As Double
'modify this routine to suit your needs
'timestamps are double values that represent a VB date
'see the VB help files for an explanation

GetTimeStamp = CalcTime

End Function

Sub UpdateOptionsDisplay()
' refreshes the current displayed parameters with values actually contained in the variables.
txtIP.Text = UDSip
txtPort.Text = Str$(UDSport)
If GenerateTimeStamps Then chkTimeStamps.Value = 1 Else chkTimeStamps.Value = 0
txtPrinterPort = Str$(PortNum)
If Product = 10 Then
    Option1.Value = True
Else
    Option2.Value = True
End If
txtTZ = Str$(TZ)
End Sub

Private Sub cmdApply_Click()
GetParamsFromDisplay
End Sub

Private Sub cmdDisconnect_Click()
'manually disconnect from SkyPipe
On Error Resume Next
If Socket1.Count = 2 Then
        If Socket1(1).Connected Then
                Socket1(1).Disconnect
        End If
End If

End Sub

Private Sub cmdGetDefaults_Click()
LoadDefaults
UpdateOptionsDisplay
End Sub

Private Sub cmdSave_Click()
GetParamsFromDisplay
SaveDefaults
End Sub

Private Sub Form_Load()
On Error Resume Next
LoadDefaults
GetParamsFromDisplay

End Sub

Private Sub Form_Unload(Cancel As Integer)
On Error Resume Next
adc10_close_unit PortNum
End Sub

Private Sub Option1_Click()
Product = 10
On Error Resume Next
adc10_close_unit PortNum
adc10_open_unit PortNum, Product

End Sub

Private Sub Option2_Click()
Product = 12
On Error Resume Next
adc10_close_unit PortNum
adc10_open_unit PortNum, Product

End Sub

Private Sub Socket1_Accept(Index As Integer, SocketId As Integer)
'we are only accepting requests on the index=0 socket
On Error Resume Next
If Index = 0 Then
        LBLstatus = "Connection Request Recieved"
        LBLstatus.Refresh
        'if we are already connected then disconnect from client (SkyPipe)
        If Socket1.Count = 2 Then
                 If Socket1(1).Connected Then Socket1(1).Disconnect
                 DoEvents
        End If
        If Socket1.Count = 1 Then Load Socket1(1)
        'we use the same ip for the connection but take the next port above the listening port
        Socket1(1).Bind UDSip, UDSport + 1
        'Accept the connection using the SocketId pass from the listening socket
        Socket1(1).Accept = SocketId
        LBLstatus = "Connected"
End If


End Sub

Private Sub Socket1_Disconnect(Index As Integer)
On Error Resume Next
If Socket1.Count = 2 Then
        Unload Socket1(1)
        'if you are running a timer for pushing your should disable it here so that you are not trying to send
        'data when not connected
        Timer1.enabled = False
End If
LBLstatus = "Disconnected"

End Sub

Private Sub Socket1_Read(Index As Integer, DataLength As Integer, IsUrgent As Integer)
'here is where we get requests and information from SkyPipe
On Error Resume Next
Dim Tstrdata As String
Dim strdata As String
Dim buf As String 'used for sending back responses
Dim CmdStr As String 'four character command string from SkyPipe
Dim Param As String  'parameter passed with command from SkypPipe if any
Dim p As Integer 'place keeper for string manipulation

'    On Error Resume Next
Socket1(1).Read strdata, DataLength

While InStr(strdata, Chr$(255)) > 1
    'strip out the command string
    Tstrdata = Left$(strdata, InStr(strdata, Chr$(255)) - 1)
    'this is what remains (if anything) in the buffer
    strdata = Right$(strdata, Len(strdata) - (Len(Tstrdata) + 1))
  
   If Len(Tstrdata) >= 4 Then ' all valid commands are 4 characters
         CmdStr = Left$(Tstrdata, 4)
         If Len(Tstrdata) > 4 Then Param = Trim(Right$(Tstrdata, Len(Tstrdata) - 4)) Else Param = ""
         Select Case CmdStr
                Case Is = "INIT" ' run any initialize routines you might have
                            LBLstatus = "Init Request Received"
                            LBLstatus.Refresh
                            UDSInit  'call the initialization routine
                Case Is = "POLL" 'SkyPipe expects polled data
                            'if you need to do something special for setting up polling do it here
                            LBLstatus = "Polling Request Received"
                            LBLstatus.Refresh
                            PollDataInit   'call routine that sets up the polling of data
                Case Is = "PUSH" 'SkyPipe expects data to be pushed by UDS
                            'if you need to set up something special for pushed data do it here
                            LBLstatus = "Push Request Received"
                            LBLstatus.Refresh
                            PushDataInit   'call the routine that sets up the pushing of data to SkyPipe
                Case Is = "GETC" 'request for the number of channels you will be using
                            LBLstatus = "Channel Request Received"
                            LBLstatus.Refresh
                            buf = "^^2013" + Trim(Str$(NumChannels)) + Chr(255) 'the last digit represents the number of channels - the NumChannels global variable
                            Socket1(1).Write buf, Len(buf) 'send the info to SkyPipe
                            DoEvents
                Case Is = "GETD" 'SkyPipe is requesting data - this is polling
                            GetSendData  ' call your routine to get your data and send it to SkyPipe
                            'if you want to generate your own timestamps in the UDS call the routine to do it
                Case Is = "STAT"
                            'now send a message saying the UDS is ready to stream data
                            buf = "^^1001" + Chr(255) '1001 is the code to SkyPipe that says lets we are ready
                            LBLstatus = "Status Request Received"
                            LBLstatus.Refresh
                            Socket1(1).Write buf, Len(buf)
                            DoEvents
                            'If you are going send your own timestamps then you should
                            'send a special timestamp using code 3002 that will tell
                            'SkyPipe where to begin the chart.
                            If GenerateTimeStamps Then
                                        buf = "^^3002" + Str$(GetTimeStamp) + Chr(255)
                                        LBLstatus = "Start Timestamp Sent"
                                        LBLstatus.Refresh
                                        Socket1(1).Write buf, Len(buf)
                            End If
           End Select
   End If

Wend


End Sub

Private Sub Timer1_Timer()
'This is part of the push data example
'when the timer event fires we will push data to SkyPipe
On Error Resume Next
Dim buf As String ' used to write data to SkyPipe
Dim TS As Double 'Timestamps are doubles
Dim D As Integer 'just a value used here to hold the phoney data we are sending
Dim PicoVal As Integer
If Socket1.Count = 2 Then ' the second socket must exist
            If Socket1(1).Connected Then 'it must also be connected
                    'this is our phoney data generating routine
                    'you would substitute here your code that actually captures the data from the external device
                    
                    PicoVal = adc10_get_value
                    buf = "#0" + Str(PicoVal) + Chr(255)
                    Socket1(1).Write buf, Len(buf)

                    'data is not updated in the strip chart until one of the following codes (3000 or 3001) is sent to SkyPipe
                    '3000 is used if you are generating your own timestamps here in the UDS
                    '3001 tells SkyPipe to generate the timestamp for you when it receives this message
                    'Note that data from all channels is sent before the timestamp is sent

                    If GenerateTimeStamps Then
                                TS = GetTimeStamp ' call your routine to generate a timestamp
                                buf = "^^3000" + Str$(TS) + Chr(255)
                                Socket1(1).Write buf, Len(buf)
                    Else
                                'let SkyPipe genrate the timestamp
                                buf = "^^3001" + Chr(255)
                                Socket1(1).Write buf, Len(buf)
                    End If
        End If

End If


End Sub

