VERSION 5.00
Object = "{33101C00-75C3-11CF-A8A0-444553540000}#1.0#0"; "CSWSK32.OCX"
Begin VB.Form UDSForm 
   Caption         =   "User Data Source"
   ClientHeight    =   3195
   ClientLeft      =   60
   ClientTop       =   345
   ClientWidth     =   6480
   KeyPreview      =   -1  'True
   LinkTopic       =   "Form1"
   ScaleHeight     =   3195
   ScaleWidth      =   6480
   StartUpPosition =   3  'Windows Default
   Begin SocketWrenchCtrl.Socket Socket1 
      Index           =   0
      Left            =   5790
      Top             =   360
      _Version        =   65536
      _ExtentX        =   741
      _ExtentY        =   741
      _StockProps     =   0
      AutoResolve     =   -1  'True
      Backlog         =   5
      Binary          =   -1  'True
      Blocking        =   0   'False
      Broadcast       =   0   'False
      BufferSize      =   1024
      HostAddress     =   ""
      HostFile        =   ""
      HostName        =   ""
      InLine          =   0   'False
      Interval        =   0
      KeepAlive       =   0   'False
      Library         =   ""
      Linger          =   0
      LocalPort       =   0
      LocalService    =   ""
      Protocol        =   0
      RemotePort      =   0
      RemoteService   =   ""
      ReuseAddress    =   0   'False
      Route           =   -1  'True
      Timeout         =   0
      Type            =   1
      Urgent          =   0   'False
   End
   Begin VB.OptionButton OptAvg 
      Caption         =   "Averaged"
      Height          =   375
      Left            =   3780
      TabIndex        =   14
      Top             =   960
      Width           =   1095
   End
   Begin VB.OptionButton OptPeak 
      Caption         =   "Peak"
      Height          =   405
      Left            =   3780
      TabIndex        =   13
      Top             =   570
      Width           =   825
   End
   Begin VB.Frame Frame1 
      Caption         =   "Channels"
      Height          =   615
      Left            =   270
      TabIndex        =   10
      Top             =   990
      Width           =   2145
      Begin VB.OptionButton OptStereo 
         Caption         =   "Stereo"
         Height          =   285
         Left            =   1050
         TabIndex        =   12
         Top             =   240
         Width           =   945
      End
      Begin VB.OptionButton OptMono 
         Caption         =   "Mono"
         Height          =   225
         Left            =   150
         TabIndex        =   11
         Top             =   270
         Width           =   705
      End
   End
   Begin VB.CommandButton cmdDisconnect 
      Caption         =   "&Disconnect"
      Height          =   345
      Left            =   180
      TabIndex        =   9
      ToolTipText     =   "Manually disconnects from SkyPipe"
      Top             =   2280
      Width           =   1125
   End
   Begin VB.CommandButton cmdApply 
      Caption         =   "&Apply"
      Height          =   315
      Left            =   5040
      TabIndex        =   8
      ToolTipText     =   "Apply changes to parameter fields."
      Top             =   2280
      Width           =   1185
   End
   Begin VB.CommandButton cmdSave 
      Caption         =   "&Save Defaults"
      Height          =   345
      Left            =   3780
      TabIndex        =   7
      ToolTipText     =   "Save the displayed parameters as the defaults."
      Top             =   2280
      Width           =   1185
   End
   Begin VB.CommandButton cmdGetDefaults 
      Caption         =   "&Get Defaults"
      Height          =   345
      Left            =   2490
      TabIndex        =   6
      ToolTipText     =   "Load defaults from the registry."
      Top             =   2280
      Width           =   1185
   End
   Begin VB.CheckBox chkTimeStamps 
      Caption         =   "Generate Time Stamps in UDS"
      Height          =   285
      Left            =   150
      TabIndex        =   5
      Top             =   1830
      Width           =   2595
   End
   Begin VB.Timer Timer1 
      Enabled         =   0   'False
      Interval        =   100
      Left            =   5790
      Top             =   870
   End
   Begin VB.TextBox txtPort 
      Height          =   285
      Left            =   1230
      TabIndex        =   2
      Text            =   "1337"
      Top             =   600
      Width           =   735
   End
   Begin VB.TextBox txtIP 
      Height          =   315
      Left            =   1230
      TabIndex        =   0
      Text            =   "127.0.0.0"
      Top             =   210
      Width           =   1125
   End
   Begin VB.Label LBLstatus 
      BorderStyle     =   1  'Fixed Single
      Height          =   315
      Left            =   180
      TabIndex        =   4
      Top             =   2700
      Width           =   6045
   End
   Begin VB.Label Label2 
      Caption         =   "Port"
      Height          =   255
      Left            =   480
      TabIndex        =   3
      Top             =   630
      Width           =   645
   End
   Begin VB.Label Label1 
      Caption         =   "IP Address"
      Height          =   255
      Left            =   300
      TabIndex        =   1
      Top             =   240
      Width           =   885
   End
End
Attribute VB_Name = "UDSForm"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
'You need the following variables if you were reading the Sound Card from SkyPipe
Dim PeakL, PeakR As Double
Dim WavgL, WavgR As Double
Dim UsePeak As Integer '

Dim DoEscape As Boolean 'escape key has been pressed Form KeyPreview must be set to True for this keypress to be detected
Dim NumChannels 'number of Channels you will be using
Dim UDSip As String 'IP address
Dim UDSport As Integer ' Port number
Dim GenerateTimeStamps As Boolean
Sub SendMsgToSkyPipe(M$)
'M$ is a string  message you want to pass to SkyPipe
'use this to send a text message to SkyPipe
'The message is passed to the same routine in  SkyPipe that processes messages
'from the Message Manager program.

'Excluding Message Appearances

'By default the messages transferred by Message Manager go to all of the destinations
'listed below. You can however exclude any of these destinations by attaching
'a prefix to the message.  The prefix contains one or more single letter flags shown below
'followed by two % signs (%%) followed by the message.

'  S - exclude from Session Log
'  C - exclude from Chat
'  I - exclude from data file header notes
'  L - exclude from the status bar
'  O - exclude from the observers log

'For example, to exclude the message from the Session log and Chat the message
'would be prefixed with:  SC%%

Dim buf As String
If Socket1.Count = 2 Then
        If Socket1(1).Connected Then
                buf = "^^1002" + M$ + Chr(255)
                Socket1(1).Write buf, Len(buf)
                DoEvents
        End If
End If

End Sub

Sub UDSInit()
Dim buf As String
'initialize anything you need to before collecting and sending data to SkyPipe
' for example, if you are generating your own timestamps in the UDS
' and you are using the CalcTime routine, this might be a good place to set
' the UToffset variable:

'Calculate UToffset with:     UToffset = -1 * (TZ / 24)
' were TZ is your timezone in hours from GMT
' if TZ was -10 then

UToffset = -1 * (-10 / 24)
DoEscape = False 'reset the escape key flag

'when using the sound card capabilities of SkyPipe we need to start the Sound input

buf = "^^5001" + Chr$(255)
If Socket1.Count = 2 Then
        If Socket1(1).Connected Then
                 Socket1(1).Write buf, Len(buf)  'send the command to start sound
        End If
End If


End Sub
Sub PushDataInit()
'this is where you would put a routine if you needed to do anything in
'preparation for pushing data to SkyPipe

'in this example  we are going to turn on a timer which push the data
Timer1.Interval = 100 'set the interval 100ms
Timer1.Enabled = True


End Sub
Sub PollDataInit()
'this is where you would put a routine if you needed to do anything in
'preparation for polling of data from SkyPipe
End Sub
Sub GetParamsFromDisplay()
If Socket1.Count = 2 Then 'make sure the second socket exists before trying to get rid of it
            If Socket1(1).Connected Then
                    Socket1(1).Disconnect
            Else
                    Socket1(1).Cleanup
                    Unload Socket1(1)
            End If
End If

If OptMono.Value = True Then
        NumChannels = 1
Else
        NumChannels = 2
End If

If OptPeak.Value = True Then
        UsePeak = 1
Else
        UsePeak = 0
End If

UDSip = txtIP
UDSport = txtPort
If chkTimeStamps.Value = 1 Then GenerateTimeStamps = True Else GenerateTimeStamps = False

'socket1(0) is the socket that the connection request arrives on from SkyPipe
'Upon receiving a connection request it will pass the connection to socket1(1) via the request id
Socket1(0).Cleanup
Socket1(0).Bind UDSip, UDSport
Socket1(0).Listen

End Sub

Sub SaveDefaults()
SaveSetting App.Title, "Settings", "IP", UDSip
SaveSetting App.Title, "Settings", "Port", Str$(UDSport)
If GenerateTimeStamps Then
        SaveSetting App.Title, "Settings", "GenerateTimeStamps", "True"
Else
        SaveSetting App.Title, "Settings", "GenerateTimeStamps", "False"
End If
SaveSetting App.Title, "Settings", "NumChannels", Str$(NumChannels)

End Sub
Sub LoadDefaults()
Dim T As String
'get the defaults from the registry
UsePeak = Val(GetSetting(App.Title, "Settings", "UsePeak", "1")) '0 = use the Avg values instead of Peak
UDSip = GetSetting(App.Title, "Settings", "IP", "127.0.0.0")
UDSport = Val(GetSetting(App.Title, "Settings", "Port", "1377"))
T = GetSetting(App.Title, "Settings", "GenerateTimeStamps", "False")
If T = "False" Then
        GenerateTimeStamps = False
Else
        GenerateTimeStamps = True
End If
NumChannels = Val(GetSetting(App.Title, "Settings", "NumChannels", "1"))
UpdateOptionsDisplay 'show options

End Sub
Sub GetSendData()
'This is routine where data is pulled from your ADC or whatever source and sent to SkyPipe
'we use this routine when data is being POLLED by SkyPipe

Dim buf As String ' used to write data to SkyPipe
Dim TS As Double 'Timestamps are doubles
Dim D As Integer 'just a value used here to hold the phoney data we are sending
Static U As Integer 'dummy data variable...get rid of it in your routine where you have real data

If Socket1.Count < 2 Or Socket1(1).Connected = False Then Exit Sub ' don't try to send data if not connected

'this is our data getting routine
'in this example we are requesting data back from the sound card through SkyPipe

If UsePeak Then 'we want the most current peak reading from the sound card
        buf = "^^5003" + Chr$(255)
        PeakL = -1 'set variables to crazy value so we can tell when they have been changed
        PeakR = -1
        Socket1(1).Write buf, Len(buf)  'send the command to get sound
        While PeakL < 0 And PeakR < 0 And Not DoEscape
                    DoEvents
        Wend
        If Not DoEscape Then
                    'we must have good data so if there is anything we want to do to it
                    'this is the place we will do it
                    'PeakL=PeakL*2   for example
        End If
        
Else  'we want to use the average peak readings from the last time we asked
        buf = "^^5004" + Chr$(255)
        WavgL = -1  'set variables to crazy value so we can tell when they have been changed
        WavgR = -1
        Socket1(1).Write buf, Len(buf)  'send the command to get sound
        While WavgL < 0 And WavgR < 0 And Not DoEscape
                    DoEvents
        Wend
        If Not DoEscape Then
                    'we must have good data so if there is anything we want to do to it
                    'this is the place we will do it
        End If
End If

If Not DoEscape Then
     If UsePeak Then
                buf = "#0" + Str(PeakR) + Chr(255)
                Socket1(1).Write buf, Len(buf)
                DoEvents
                If NumChannels = 2 Then
                        buf = "#1" + Str(PeakL) + Chr(255)
                        Socket1(1).Write buf, Len(buf)
                        DoEvents
                End If
    Else        'we are using the average values
                buf = "#0" + Str(WavgR) + Chr(255)
                Socket1(1).Write buf, Len(buf)
                DoEvents
                If NumChannels = 2 Then
                        buf = "#1" + Str(WavgL) + Chr(255)
                        Socket1(1).Write buf, Len(buf)
                        DoEvents
                End If
    End If
End If
    
If DoEscape Then 'somebody pressed the escape ke so things aren't going right
            If Socket1.Count = 2 Then
                        If Socket1(1).Connected Then Socket1(1).Disconnect  'lets quit
            End If
End If
    
    
'data is not updated in the strip chart until one of the following codes (3000 or 3001) is sent to SkyPipe
'3000 is used if you are generating your own timestamps here in the UDS
'3001 tells SkyPipe to generate the timestamp for you when it receives this message
'Note that data from all channels is sent before the timestamp is sent

If GenerateTimeStamps Then
        TS = GetTimeStamp ' call your routine to generate a timestamp
        buf = "^^3000" + Str$(TS) + Chr(255)
        Socket1(1).Write buf, Len(buf)
Else
        'let SkyPipe genrate the timestamp
        buf = "^^3001" + Chr(255)
        Socket1(1).Write buf, Len(buf)
End If

End Sub
Function GetTimeStamp() As Double
'modify this routine to suit your needs
'timestamps are double values that represent a VB date
'see the VB help files for an explanation

GetTimeStamp = CalcTime

End Function

Sub UpdateOptionsDisplay()
' refreshes the current displayed parameters with values actually contained in the variables.
If UsePeak = 1 Then
        OptPeak.Value = True
        OptAvg.Value = False
Else
        OptPeak.Value = False
        OptAvg.Value = True
End If
If NumChannels = 1 Then
        OptMono.Value = True
        OptStereo.Value = False
Else
        NumChannels = 2 'has to be one or two for this example
        OptMono.Value = False
        OptStereo.Value = True
End If

txtIP.Text = UDSip
txtPort.Text = Str$(UDSport)
If GenerateTimeStamps Then chkTimeStamps.Value = 1 Else chkTimeStamps.Value = 0
txtChannels = Str$(NumChannels)
End Sub

Private Sub cmdApply_Click()
GetParamsFromDisplay
End Sub

Private Sub cmdDisconnect_Click()
'manually disconnect from SkyPipe

If Socket1.Count = 2 Then
        If Socket1(1).Connected Then
                Socket1(1).Disconnect
        End If
End If

End Sub

Private Sub cmdGetDefaults_Click()
LoadDefaults
UpdateOptionsDisplay
End Sub

Private Sub cmdSave_Click()
GetParamsFromDisplay
SaveDefaults
End Sub

Private Sub Form_KeyPress(KeyAscii As Integer)
If KeyAscii = vbKeyEscape Then
        DoEscape = True
End If

End Sub

Private Sub Form_Load()
On Error Resume Next
LoadDefaults
GetParamsFromDisplay

End Sub

Private Sub Socket1_Accept(Index As Integer, SocketId As Integer)
'we are only accepting requests on the index=0 socket

If Index = 0 Then
        LBLstatus = "Connection Request Recieved"
        LBLstatus.Refresh
        'if we are already connected then disconnect from client (SkyPipe)
        If Socket1.Count = 2 Then
                 If Socket1(1).Connected Then Socket1(1).Disconnect
                 DoEvents
        End If
        If Socket1.Count = 1 Then Load Socket1(1)
        'we use the same ip for the connection but take the next port above the listening port
        Socket1(1).Bind UDSip, UDSport + 1
        'Accept the connection using the SocketId pass from the listening socket
        Socket1(1).Accept = SocketId
        LBLstatus = "Connected"
End If


End Sub

Private Sub Socket1_Disconnect(Index As Integer)
If Socket1.Count = 2 Then
        Unload Socket1(1)
        'if you are running a timer for pushing your should disable it here so that you are not trying to send
        'data when not connected
        Timer1.Enabled = False
End If
LBLstatus = "Disconnected"

End Sub

Private Sub Socket1_Read(Index As Integer, DataLength As Integer, IsUrgent As Integer)
'here is where we get requests and information from SkyPipe

Dim Tstrdata As String
Dim strdata As String
Dim buf As String 'used for sending back responses
Dim CmdStr As String 'four character command string from SkyPipe
Dim Param As String  'parameter passed with command from SkypPipe if any
Dim p As Integer 'place keeper for string manipulation




'    On Error Resume Next
Socket1(1).Read strdata, DataLength

While InStr(strdata, Chr$(255)) > 1
    'strip out the command string
    Tstrdata = Left$(strdata, InStr(strdata, Chr$(255)) - 1)
    'this is what remains (if anything) in the buffer
    strdata = Right$(strdata, Len(strdata) - (Len(Tstrdata) + 1))
    
   
   If Len(Tstrdata) >= 4 Then ' all valid commands are 4 characters
         CmdStr = Left$(Tstrdata, 4)
         If Len(Tstrdata) > 4 Then Param = Trim(Right$(Tstrdata, Len(Tstrdata) - 4)) Else Param = ""
         Select Case CmdStr
                Case Is = "INIT" ' run any initialize routines you might have
                            LBLstatus = "Init Request Received"
                            LBLstatus.Refresh
                            UDSInit  'call the initialization routine
                Case Is = "POLL" 'SkyPipe expects polled data
                            'if you need to do something special for setting up polling do it here
                            LBLstatus = "Polling Request Received"
                            LBLstatus.Refresh
                            PollDataInit   'call routine that sets up the polling of data
                Case Is = "PUSH" 'SkyPipe expects data to be pushed by UDS
                            'if you need to set up something special for pushed data do it here
                            LBLstatus = "Push Request Received"
                            LBLstatus.Refresh
                            PushDataInit   'call the routine that sets up the pushing of data to SkyPipe
                Case Is = "GETC" 'request for the number of channels you will be using
                            LBLstatus = "Channel Request Received"
                            LBLstatus.Refresh
                            buf = "^^2013" + Trim(Str$(NumChannels)) + Chr(255) 'the last digit represents the number of channels - the NumChannels global variable
                            Socket1(1).Write buf, Len(buf) 'send the info to SkyPipe
                            DoEvents
                Case Is = "GETD" 'SkyPipe is requesting data - this is polling
                            GetSendData  ' call your routine to get your data and send it to SkyPipe
                            'if you want to generate your own timestamps in the UDS call the routine to do it
                Case Is = "STAT"
                            'now send a message saying the UDS is ready to stream data
                            buf = "^^1001" + Chr(255) '1001 is the code to SkyPipe that says lets we are ready
                            LBLstatus = "Status Request Received"
                            LBLstatus.Refresh
                            Socket1(1).Write buf, Len(buf)
                            DoEvents
                            'If you are going send your own timestamps then you should
                            'send a special timestamp using code 3002 that will tell
                            'SkyPipe where to begin the chart.
                            If GenerateTimeStamps Then
                                        buf = "^^3002" + Str$(GetTimeStamp) + Chr(255)
                                        LBLstatus = "Start Timestamp Sent"
                                        LBLstatus.Refresh
                                        Socket1(1).Write buf, Len(buf)
                            End If
                Case Is = "PINH" ' the requested status of a parallel port pin is high
                
                Case Is = "PINL" ' the requested status of a parallel port pin is Low
                            
                Case Is = "PEAK" 'peak buffers for Sound card being returned
                            If Len(Param) > 0 Then
                                    p = InStr(Param, " ") 'is there a space?
                                    If p > 0 Then 'there must be data for left channel also
                                                PeakR = Val(Left$(Param, p - 1))
                                                PeakL = Val(Right$(Param, Len(Param) - p))
                                    Else
                                                PeakR = Val(Param)
                                                PeakL = 0
                                    End If
                                    'Call Routine here process the Peak sound card values..
                
                            End If
                Case Is = "WAVG" 'peak buffers for Sound card being returned
                            If Len(Param) > 0 Then
                                    p = InStr(Param, " ") 'is there a space?
                                    If p > 0 Then 'there must be data for left channel also
                                                WavgR = Val(Left$(Param, p - 1))
                                                WavgL = Val(Right$(Param, Len(Param) - p))
                                    Else
                                                WavgR = Val(Param)
                                                WavgL = 0
                                    End If
                                    'Call Routine here process the Averaged sound card values..
                            End If
          End Select
   End If

Wend


End Sub

Private Sub Timer1_Timer()
'This is part of the push data example
'when the timer event fires we will push data to SkyPipe

GetSendData
If DoEscape Then Timer1.Enabled = False

End Sub
