Attribute VB_Name = "MaxADC"
Option Explicit
'WinIo.bas required

'Printer Variables
Public LptPortAddr%
'Global ADC and Digital I/O Variables
Public LPTData%, LPTStatus%, LPTControl%
Public LPTPortAdd%
Public DataReg, StatusReg, ControlReg As Long
Sub InitPrinterPort(LPTPortAdd%)
' The function InitPrinterPort initialises the printer port used to control
   On Error Resume Next
    LPTData% = LPTPortAdd%
    LPTStatus% = LPTData% + 1
    LPTControl% = LPTData% + 2
    DataReg = 0
    ControlReg = &HA    '### was hfa Strobe and Init low Autofd high */
    Call SetPortVal(LPTControl%, ControlReg, 2)
End Sub
Function GetMax186(Channel%) As Integer

 On Error Resume Next
 Dim Word%, i%
 Dim r As Boolean
 Dim Bit, Mask As Long
    ControlReg = &HA    '### was hfa Strobe and Init low Autofd high */
    Call SetPortVal(LPTControl%, ControlReg, 2)
    Call SetPortVal(LPTData%, &H0, 2)  'SCLK Low, DIN Low */
    'ControlReg = ControlReg And &HFD
    Call SetPortVal(LPTControl%, ControlReg, 2) 'CS Low
    Channel% = Channel% ' - 1
    'Signals start of control byte
    
    'Din Hi Clk Lo
    Call SetPortVal(LPTData%, &H2, 2)
    'Din Hi Clk Hi
    Call SetPortVal(LPTData%, &H3, 2)
    
    'SEL2 Bit
    If Channel And &H1 Then
        'Din Hi Clk Lo
        Call SetPortVal(LPTData%, &H2, 2)
        'Din Hi Clk Hi
        Call SetPortVal(LPTData%, &H3, 2)
    Else
        'Din Lo Clk Lo
        Call SetPortVal(LPTData%, &H0, 2)
        'Din Lo Clk Hi
        Call SetPortVal(LPTData%, &H1, 2)
    End If
    
    'SEL1 bit
    If Channel > 3 Then
        'Din Hi Clk Lo
        Call SetPortVal(LPTData%, &H2, 2)
        'Din Hi Clk Hi
        Call SetPortVal(LPTData%, &H3, 2)
    Else
        'Din Lo Clk Lo
        Call SetPortVal(LPTData%, &H0, 2)
        'Din Lo Clk Hi
        Call SetPortVal(LPTData%, &H1, 2)
    End If
    
    'SEL0 bit
    If Channel And &H2 Then
        'Din Hi Clk Lo
        Call SetPortVal(LPTData%, &H2, 2)
        'Din Hi Clk Hi
        Call SetPortVal(LPTData%, &H3, 2)
    Else
        'Din Lo Clk Lo
        Call SetPortVal(LPTData%, &H0, 2)
        'Din Lo Clk Hi
        Call SetPortVal(LPTData%, &H1, 2)
    End If
    
    
    'Unipolar so clk out a Hi
    
        'Din Hi Clk Lo
        Call SetPortVal(LPTData%, &H2, 2)
        'Din Hi Clk Hi
        Call SetPortVal(LPTData%, &H3, 2)
    
    'Single Ended so clk out a Hi
        'Din Hi Clk Lo
        Call SetPortVal(LPTData%, &H2, 2)
        'Din Hi Clk Hi
        Call SetPortVal(LPTData%, &H3, 2)
    
    'Internal Clk Mode
        'Din Hi Clk Lo
        Call SetPortVal(LPTData%, &H2, 2)
        'Din Hi Clk Hi
        Call SetPortVal(LPTData%, &H3, 2)
        'Din Lo Clk Lo
        Call SetPortVal(LPTData%, &H0, 2)
        'Din Lo Clk Hi
        Call SetPortVal(LPTData%, &H1, 2)
    
    'Bring Din and Clk low
    Call SetPortVal(LPTData%, &H0, 2)
    'For i = 1 To 10000
    'Next i
  
    Word% = 0
    For i = 0 To 11
        Word% = Word% * 2
        Call SetPortVal(LPTData%, &H1, 2)       'Bring Clk High                                                         'Bring Clk High */
        
        Call SetPortVal(LPTData%, &H0, 2)       'Bring Clk Low
    
        r = GetPortVal(LPTStatus%, Bit, 1) 'read ADC's Data Out
        
        Bit = Bit And &H8
        If Bit <> 0 Then
            Word% = Word% Or &H1
        End If
    Next i
    ControlReg = ControlReg And &HFD
    Call SetPortVal(LPTControl%, ControlReg, 2)                      'Bring CS High */
    GetMax186 = Word%
    
End Function
Function GetMax187() As Integer
On Error Resume Next
Dim q%
Dim PortVal As Long
Dim Accum%
Dim r As Boolean

Accum% = 0

r = SetPortVal(LPTData%, 1, 2)
r = SetPortVal(LPTData%, 0, 2)
r = GetPortVal(LPTStatus%, PortVal, 2)
r = GetPortVal(LPTStatus%, PortVal, 2)
r = SetPortVal(LPTData%, 2, 2)
r = SetPortVal(LPTData%, 0, 2)
r = SetPortVal(LPTData%, 2, 2)
r = GetPortVal(LPTStatus%, PortVal, 2)
If (PortVal And 32) > 0 Then Accum% = 2048
r = SetPortVal(LPTData%, 0, 2)
r = SetPortVal(LPTData%, 2, 2)
r = GetPortVal(LPTStatus%, PortVal, 2)
If (PortVal And 32) > 0 Then Accum% = Accum% + 1024
r = SetPortVal(LPTData%, 0, 2)
r = SetPortVal(LPTData%, 2, 2)
r = GetPortVal(LPTStatus%, PortVal, 2)
If (PortVal And 32) > 0 Then Accum% = Accum% + 512
r = SetPortVal(LPTData%, 0, 2)
r = SetPortVal(LPTData%, 2, 2)
r = GetPortVal(LPTStatus%, PortVal, 2)
If (PortVal And 32) > 0 Then Accum% = Accum% + 256
r = SetPortVal(LPTData%, 0, 2)
r = SetPortVal(LPTData%, 2, 2)
r = GetPortVal(LPTStatus%, PortVal, 2)
If (PortVal And 32) > 0 Then Accum% = Accum% + 128
r = SetPortVal(LPTData%, 0, 2)
r = SetPortVal(LPTData%, 2, 2)
r = GetPortVal(LPTStatus%, PortVal, 2)
If (PortVal And 32) > 0 Then Accum% = Accum% + 64
r = SetPortVal(LPTData%, 0, 2)
r = SetPortVal(LPTData%, 2, 2)
r = GetPortVal(LPTStatus%, PortVal, 2)
If (PortVal And 32) > 0 Then Accum% = Accum% + 32
r = SetPortVal(LPTData%, 0, 2)
r = SetPortVal(LPTData%, 2, 2)
r = GetPortVal(LPTStatus%, PortVal, 2)
If (PortVal And 32) > 0 Then Accum% = Accum% + 16
r = SetPortVal(LPTData%, 0, 2)
r = SetPortVal(LPTData%, 2, 2)
r = GetPortVal(LPTStatus%, PortVal, 2)
If (PortVal And 32) > 0 Then Accum% = Accum% + 8
r = SetPortVal(LPTData%, 0, 2)
r = SetPortVal(LPTData%, 2, 2)
r = GetPortVal(LPTStatus%, PortVal, 2)
If (PortVal And 32) > 0 Then Accum% = Accum% + 4
r = SetPortVal(LPTData%, 0, 2)
r = SetPortVal(LPTData%, 2, 2)
r = GetPortVal(LPTStatus%, PortVal, 2)
If (PortVal And 32) > 0 Then Accum% = Accum% + 2
r = SetPortVal(LPTData%, 0, 2)
r = SetPortVal(LPTData%, 2, 2)
r = GetPortVal(LPTStatus%, PortVal, 2)
If (PortVal And 32) > 0 Then Accum% = Accum% + 1
r = SetPortVal(LPTData%, 2, 2)
r = SetPortVal(LPTData%, 0, 2)
r = SetPortVal(LPTData%, 2, 2)
r = SetPortVal(LPTData%, 0, 2)
r = SetPortVal(LPTData%, 1, 2)
GetMax187 = Accum%

End Function


