VERSION 5.00
Object = "{33101C00-75C3-11CF-A8A0-444553540000}#1.0#0"; "CSWSK32.OCX"
Object = "{648A5603-2C6E-101B-82B6-000000000014}#1.1#0"; "Mscomm32.ocx"
Begin VB.Form UDSForm 
   Caption         =   "RS232UDS"
   ClientHeight    =   6000
   ClientLeft      =   60
   ClientTop       =   345
   ClientWidth     =   7335
   KeyPreview      =   -1  'True
   LinkTopic       =   "Form1"
   ScaleHeight     =   6000
   ScaleWidth      =   7335
   StartUpPosition =   3  'Windows Default
   Begin SocketWrenchCtrl.Socket Socket1 
      Index           =   0
      Left            =   6870
      Top             =   5130
      _Version        =   65536
      _ExtentX        =   741
      _ExtentY        =   741
      _StockProps     =   0
      AutoResolve     =   -1  'True
      Backlog         =   5
      Binary          =   -1  'True
      Blocking        =   0   'False
      Broadcast       =   0   'False
      BufferSize      =   1024
      HostAddress     =   ""
      HostFile        =   ""
      HostName        =   ""
      InLine          =   0   'False
      Interval        =   0
      KeepAlive       =   0   'False
      Library         =   ""
      Linger          =   0
      LocalPort       =   0
      LocalService    =   ""
      Protocol        =   0
      RemotePort      =   0
      RemoteService   =   ""
      ReuseAddress    =   0   'False
      Route           =   -1  'True
      Timeout         =   0
      Type            =   1
      Urgent          =   0   'False
   End
   Begin VB.CheckBox chkShowSamples 
      Caption         =   "Shows Samples in Status Bar"
      Height          =   675
      Left            =   5940
      TabIndex        =   49
      ToolTipText     =   "Diagnostic option. Displays pre and post processed samples arriving from rs232 device in status bar."
      Top             =   1770
      Width           =   1215
   End
   Begin VB.TextBox txtStrip 
      Height          =   255
      Left            =   2010
      TabIndex        =   46
      ToolTipText     =   $"RS232UDSForm.frx":0000
      Top             =   2790
      Width           =   3705
   End
   Begin VB.Frame Frame3 
      Height          =   465
      Left            =   270
      TabIndex        =   41
      Top             =   3630
      Width           =   5535
      Begin VB.TextBox txtFixedRate 
         Height          =   255
         Left            =   3210
         TabIndex        =   44
         Text            =   "100"
         ToolTipText     =   "If device streams data at fixed intervals indicate the sample period here in milliseconds."
         Top             =   150
         Width           =   1185
      End
      Begin VB.OptionButton OptStreamed 
         Caption         =   "Polled Samples"
         Height          =   285
         Index           =   1
         Left            =   30
         TabIndex        =   43
         ToolTipText     =   "Each sample is polled from the rs232 device using a Poll Command."
         Top             =   150
         Width           =   1395
      End
      Begin VB.OptionButton OptStreamed 
         Caption         =   "Data is Streamed at"
         Height          =   285
         Index           =   0
         Left            =   1500
         TabIndex        =   42
         ToolTipText     =   "Data streams from the device without being polled for each new sample.  "
         Top             =   150
         Width           =   1725
      End
      Begin VB.Label Label13 
         Caption         =   "ms. intervals."
         Height          =   255
         Left            =   4410
         TabIndex        =   45
         Top             =   180
         Width           =   945
      End
   End
   Begin VB.CheckBox chkReverse 
      Caption         =   "16 Bit Reverse Byte Order"
      Height          =   585
      Left            =   5970
      TabIndex        =   39
      ToolTipText     =   "16 bit binary data is returned from rs232 device in reverse order, that is, MSB then LSB."
      Top             =   2490
      Width           =   1275
   End
   Begin VB.Frame Frame2 
      Caption         =   "Com Port "
      Height          =   1035
      Left            =   3480
      TabIndex        =   34
      Top             =   210
      Width           =   2235
      Begin VB.TextBox txtSettings 
         Height          =   285
         Left            =   900
         TabIndex        =   38
         Text            =   "9600,N,8,1"
         ToolTipText     =   "Baud,Parity,Bits,Stop Bits"
         Top             =   600
         Width           =   1215
      End
      Begin VB.TextBox txtComPort 
         Height          =   285
         Left            =   900
         TabIndex        =   36
         Text            =   "1"
         Top             =   270
         Width           =   285
      End
      Begin VB.Label Label3 
         Caption         =   "Settings"
         Height          =   225
         Left            =   150
         TabIndex        =   37
         Top             =   630
         Width           =   615
      End
      Begin VB.Label Label4 
         Caption         =   "Com Port"
         Height          =   255
         Left            =   150
         TabIndex        =   35
         Top             =   300
         Width           =   765
      End
   End
   Begin VB.Frame Frame1 
      Height          =   435
      Left            =   2640
      TabIndex        =   30
      Top             =   3150
      Width           =   4485
      Begin VB.OptionButton OptSampleType 
         Caption         =   "HEX"
         Height          =   255
         Index           =   3
         Left            =   1080
         TabIndex        =   48
         ToolTipText     =   "Numerical data is returned fron the rs232 device as an HEX string. For example; FE01"
         Top             =   150
         Width           =   765
      End
      Begin VB.OptionButton OptSampleType 
         Caption         =   "8 Bit Binary"
         Height          =   255
         Index           =   2
         Left            =   3180
         TabIndex        =   33
         ToolTipText     =   "RS232 Device returns a single 8 bit byte as the data sample."
         Top             =   150
         Width           =   1185
      End
      Begin VB.OptionButton OptSampleType 
         Caption         =   "16 Bit Binary"
         Height          =   255
         Index           =   1
         Left            =   1950
         TabIndex        =   32
         ToolTipText     =   "Numerical data is returned fron the rs232 device as a 2 byte binary value. Normal order is LSB then MSB."
         Top             =   150
         Width           =   1245
      End
      Begin VB.OptionButton OptSampleType 
         Caption         =   "ASCII"
         Height          =   255
         Index           =   0
         Left            =   90
         TabIndex        =   31
         ToolTipText     =   "Numerical data is returned fron the rs232 device as an ASCII string. For example; +2367"
         Top             =   150
         Width           =   765
      End
   End
   Begin VB.TextBox txtSampleLen 
      Height          =   255
      Left            =   1740
      TabIndex        =   28
      ToolTipText     =   "If sample has a fixed length (number of characters) it goes here. 0 or blank if not a fixed length."
      Top             =   3270
      Width           =   735
   End
   Begin VB.TextBox txtSOS 
      Height          =   255
      Left            =   1860
      TabIndex        =   26
      ToolTipText     =   "Start of Sample Marker. Leave blank if none exists."
      Top             =   2160
      Width           =   3855
   End
   Begin VB.TextBox txtEOS 
      Height          =   255
      Left            =   1860
      TabIndex        =   24
      ToolTipText     =   "End of Sample Marker. Leave blank if none exists."
      Top             =   2490
      Width           =   3855
   End
   Begin VB.TextBox txtInterval 
      Height          =   255
      Left            =   1320
      TabIndex        =   22
      Text            =   "100"
      ToolTipText     =   "Use only if each sample must be polled for by the UDS and if this UDS is pushing data to SkyPipe."
      Top             =   4230
      Width           =   705
   End
   Begin VB.TextBox txtPollCmd 
      Height          =   255
      Left            =   1290
      TabIndex        =   20
      ToolTipText     =   "Command sent to RS232 device to retrieve a data sample. Leave blank if no such command is used."
      Top             =   1830
      Width           =   4425
   End
   Begin VB.TextBox txtInit 
      Height          =   255
      Left            =   1290
      TabIndex        =   18
      ToolTipText     =   "Command sent to RS232 device when the UDS Init Routine is run. Leave Blank for no command."
      Top             =   1500
      Width           =   4425
   End
   Begin VB.TextBox txtTZ 
      Height          =   285
      Left            =   1080
      TabIndex        =   16
      Text            =   "0"
      Top             =   930
      Width           =   495
   End
   Begin VB.TextBox txtCmd 
      Height          =   285
      Index           =   2
      Left            =   1380
      TabIndex        =   15
      ToolTipText     =   "User defined command 3. This command goes to the RS232 device."
      Top             =   5220
      Width           =   5205
   End
   Begin VB.CommandButton Cmd 
      Caption         =   "Command"
      Height          =   275
      Index           =   2
      Left            =   240
      TabIndex        =   14
      Top             =   5220
      Width           =   1065
   End
   Begin VB.TextBox txtCmd 
      Height          =   285
      Index           =   1
      Left            =   1380
      TabIndex        =   13
      ToolTipText     =   "User defined command 2. This command goes to the RS232 device."
      Top             =   4890
      Width           =   5205
   End
   Begin VB.CommandButton Cmd 
      Caption         =   "Command"
      Height          =   275
      Index           =   1
      Left            =   240
      TabIndex        =   12
      Top             =   4890
      Width           =   1065
   End
   Begin VB.TextBox txtCmd 
      Height          =   285
      Index           =   0
      Left            =   1380
      TabIndex        =   11
      ToolTipText     =   "User defined command 1. This command goes to the RS232 device."
      Top             =   4560
      Width           =   5205
   End
   Begin VB.CommandButton Cmd 
      Caption         =   "Command"
      Height          =   275
      Index           =   0
      Left            =   240
      TabIndex        =   10
      Top             =   4560
      Width           =   1065
   End
   Begin MSCommLib.MSComm MSComm1 
      Left            =   6660
      Top             =   4020
      _ExtentX        =   1005
      _ExtentY        =   1005
      _Version        =   393216
      DTREnable       =   -1  'True
   End
   Begin VB.CommandButton cmdDisconnect 
      Caption         =   "&Disconnect"
      Height          =   345
      Left            =   5970
      TabIndex        =   9
      ToolTipText     =   "Manually disconnects from SkyPipe"
      Top             =   1380
      Width           =   1185
   End
   Begin VB.CommandButton cmdApply 
      Caption         =   "&Apply"
      Height          =   315
      Left            =   5970
      TabIndex        =   8
      ToolTipText     =   "Apply changes to parameter fields."
      Top             =   990
      Width           =   1185
   End
   Begin VB.CommandButton cmdSave 
      Caption         =   "&Save Defaults"
      Height          =   345
      Left            =   5970
      TabIndex        =   7
      ToolTipText     =   "Save the displayed parameters as the defaults."
      Top             =   600
      Width           =   1185
   End
   Begin VB.CommandButton cmdGetDefaults 
      Caption         =   "&Get Defaults"
      Height          =   345
      Left            =   5970
      TabIndex        =   6
      ToolTipText     =   "Load defaults from the registry."
      Top             =   210
      Width           =   1185
   End
   Begin VB.CheckBox chkTimeStamps 
      Caption         =   "Generate Time Stamps in UDS"
      Height          =   285
      Left            =   270
      TabIndex        =   5
      Top             =   600
      Width           =   2595
   End
   Begin VB.Timer Timer1 
      Enabled         =   0   'False
      Interval        =   100
      Left            =   6810
      Top             =   4680
   End
   Begin VB.TextBox txtPort 
      Height          =   285
      Left            =   2430
      TabIndex        =   2
      Text            =   "1337"
      Top             =   210
      Width           =   735
   End
   Begin VB.TextBox txtIP 
      Height          =   315
      Left            =   960
      TabIndex        =   0
      Text            =   "127.0.0.1"
      Top             =   210
      Width           =   1035
   End
   Begin VB.Label Label14 
      Caption         =   "Strip this String from Data"
      Height          =   225
      Left            =   90
      TabIndex        =   47
      Top             =   2790
      Width           =   1875
   End
   Begin VB.Label Label5 
      Caption         =   "Timer Interval"
      Height          =   225
      Left            =   210
      TabIndex        =   40
      Top             =   4260
      Width           =   1035
   End
   Begin VB.Label Label12 
      Caption         =   "Fixed Sample Length"
      Height          =   255
      Left            =   180
      TabIndex        =   29
      Top             =   3270
      Width           =   1485
   End
   Begin VB.Label Label11 
      Caption         =   "Start of Sample Marker"
      Height          =   225
      Left            =   150
      TabIndex        =   27
      Top             =   2160
      Width           =   1665
   End
   Begin VB.Label Label10 
      Caption         =   "End of Sample Marker"
      Height          =   225
      Left            =   180
      TabIndex        =   25
      Top             =   2490
      Width           =   1665
   End
   Begin VB.Label Label9 
      Caption         =   "ms. Setting to 0 uses the com port interrupt trigger."
      Height          =   255
      Left            =   2070
      TabIndex        =   23
      Top             =   4230
      Width           =   3675
   End
   Begin VB.Label Label8 
      Caption         =   "Poll Command"
      Height          =   195
      Left            =   180
      TabIndex        =   21
      Top             =   1860
      Width           =   1095
   End
   Begin VB.Label Label7 
      Caption         =   "Init Command"
      Height          =   285
      Left            =   210
      TabIndex        =   19
      Top             =   1530
      Width           =   1035
   End
   Begin VB.Line Line1 
      X1              =   270
      X2              =   5640
      Y1              =   1380
      Y2              =   1380
   End
   Begin VB.Label Label6 
      Caption         =   "Time Zone"
      Height          =   255
      Left            =   240
      TabIndex        =   17
      Top             =   960
      Width           =   945
   End
   Begin VB.Label LBLstatus 
      BackColor       =   &H00800000&
      BorderStyle     =   1  'Fixed Single
      ForeColor       =   &H0080FFFF&
      Height          =   315
      Left            =   150
      TabIndex        =   4
      Top             =   5610
      Width           =   6945
   End
   Begin VB.Label Label2 
      Caption         =   "Port"
      Height          =   255
      Left            =   2040
      TabIndex        =   3
      Top             =   240
      Width           =   375
   End
   Begin VB.Label Label1 
      Caption         =   "IP Address"
      Height          =   255
      Left            =   150
      TabIndex        =   1
      Top             =   240
      Width           =   885
   End
End
Attribute VB_Name = "UDSForm"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
Dim InBuf As String 'where we hold data coming from the device
Dim Pushing As Boolean 'sets pushing of data by the uds to SkyPipe
Dim Started As Boolean ' last second hold on sending data
Const vASCII = 0  'data types
Const v16Bit = 1
Const v8Bit = 2
Dim vDataType As Integer
Dim Reverse As Boolean 'reverse byte order for 16 bit - normal = LSB then MSB
Dim PollCmd As String
Dim InitCmd As String
Dim EOSM As String 'end of sample marker
Dim SOSM As String 'start of sample marker
Dim Strip As String 'if present this string is stripped from an incoming sample string
Dim SampleLen As Long
Dim vInterval As Long
Dim TZ As Double
Dim EscapePressed As Boolean   'monitor the form for the press of the escape button to get us out of loops.
Dim BusyReadingMeter As Boolean 'we need this to prevent the calling of the routine again before it is done
Dim ComPort As Integer
Dim NumChannels 'number of Channels you will be using
Dim ComPortSettings As String
Dim UDSip As String 'IP address
Dim UDSport As Integer ' Port number
Dim GenerateTimeStamps As Boolean

Sub SendMsgToSkyPipe(M$)
'M$ is a string  message you want to pass to SkyPipe
'use this to send a text message to SkyPipe
'The message is passed to the same routine in  SkyPipe that processes messages
'from the Message Manager program.

'Excluding Message Appearances

'By default the messages transferred by Message Manager go to all of the destinations
'listed in the first list above. You can however exclude any of these destinations by attaching
'a prefix to the message.  The prefix contains one or more single letter flags shown below
'followed by two % signs (%%) followed by the message.

'  S - exclude from Session Log
'  C - exclude from Chat
'  I - exclude from data file header notes
'  L - exclude from the status bar
'  O - exclude from the observers log

'For example, to exclude the message from the Session log and Chat the message
'would be prefixed with:  SC%%

Dim buf As String
If Socket1.Count = 2 Then
        If Socket1(1).Connected Then
                buf = "^^1002" + M$ + Chr(255)
                Socket1(1).Write buf, Len(buf)
                DoEvents
        End If
End If

End Sub

Sub UDSInit()
'initialize anything you need to before collecting and sending data to SkyPipe
' for example, if you are generating your own timestamps in the UDS
' and you are using the CalcTime routine, this might be a good place to set
' the UToffset variable:

'Calculate UToffset with:     UToffset = -1 * (TZ / 24)
' were TZ is your timezone in hours from GMT
' if TZ was -10 then

UToffset = -1 * (TZ / 24)

'reset the escape key flag
EscapePressed = False
'BusyReadingMeter = False
'

If MSComm1.PortOpen Then MSComm1.PortOpen = False   'close the port if it is open
MSComm1.CommPort = ComPort
MSComm1.Settings = ComPortSettings '1200 baud, no parity, 7 data bits, 2 stop bits
MSComm1.PortOpen = True 'reopen the port for business
A$ = MSComm1.Input ' clear out anything sitting in the input buffer

End Sub
Function ProcessSample(Sstr) As Double
If chkShowSamples.Value <> 0 Then
        lbls.Caption = Sstr
End If
If Len(SOSM) > 0 Then
             'strip off anything that is to the left of the start of sample marker.

Wend




End Function
Sub PushDataInit()
'this is where you would put a routine if you needed to do anything in
'preparation for pushing data to SkyPipe

'in this example  we are going to turn on a timer which push the data
If vInterval > 0 Then
        Timer1.Interval = vInterval
        Timer1.Enabled = True
End If
Pushing = True
End Sub
Sub PollDataInit()
'this is where you would put a routine if you needed to do anything in
'preparation for polling of data from SkyPipe
Pushing = False
End Sub
Sub GetParamsFromDisplay()

If Socket1.Count = 2 Then 'make sure the second socket exists before trying to get rid of it
            If Socket1(1).Connected Then
                    Socket1(1).Disconnect
            Else
                    Socket1(1).Cleanup
                    Unload Socket1(1)
            End If
End If
TZ = Val(txtTZ)
UToffset = -1 * (TZ / 24)
UDSip = txtIP
UDSport = txtPort
If chkTimeStamps.Value = 1 Then GenerateTimeStamps = True Else GenerateTimeStamps = False
If chkReverse.Value = 1 Then Reverse = True Else Reverse = False
PollCmd = Interpret(txtPollCmd.Text)
InitCmd = Interpret(txtInit.Text)
Timer1.Interval = Val(txtInterval.Text)
Strip = Interpret(txtStrip.Text)
For i = 0 To 2
    If OptSampleType(i).Value = True Then vDataType = i: Exit For
Next i
ComPort = Val(txtComPort)
If MSComm1.PortOpen = True Then MSComm1.PortOpen = False
MSComm1.CommPort = ComPort
ComPortSettings = txtSettings
MSComm1.Settings = ComPortSettings
'socket1(0) is the socket that the connection request arrives on from SkyPipe
'Upon receiving a connection request it will pass the connection to socket1(1) via the request id
Socket1(0).Cleanup
Socket1(0).Bind UDSip, UDSport
Socket1(0).Listen

End Sub

Sub SaveDefaults()
SaveSetting App.Title, "Settings", "IP", UDSip
SaveSetting App.Title, "Settings", "Port", Str$(UDSport)
If GenerateTimeStamps Then
        SaveSetting App.Title, "Settings", "GenerateTimeStamps", "True"
Else
        SaveSetting App.Title, "Settings", "GenerateTimeStamps", "False"
End If
If Reverse Then
        SaveSetting App.Title, "Settings", "Reverse", "True"
Else
        SaveSetting App.Title, "Settings", "Reverse", "False"
End If

For i = 0 To 2
        SaveSetting App.Title, "Settings", "txtCmd" + Trim(Str$(i)), txtCmd(i).Text
Next i
SaveSetting App.Title, "Settings", "ComPortSettings", ComPortSettings
SaveSetting App.Title, "Settings", "ComPort", Str$(ComPort)
SaveSetting App.Title, "Settings", "TZ", Str$(TZ)
SaveSetting App.Title, "Settings", "vDataType", Str$(vDataType)
SaveSetting App.Title, "Settings", "PollCmd", txtPollCmd.Text
SaveSetting App.Title, "Settings", "InitCmd", txtInit.Text
SaveSetting App.Title, "Settings", "Strip", txtStrip.Text
End Sub
Function Interpret(M As String) As String
'Replaces the following with correct ascii character
'CRLF
'CHR(X)
Dim p
M = Trim(M)
If Len(M) = 0 Then Interpret = "": Exit Function
Dim A$
Dim B$
Dim C$

A$ = Replace(M, "CRLF", vbCrLf)
p = InStr(A$, "CHR(")
While p > 0
        B$ = Mid$(A$, p, InStr(p, A$, ")") - (p - 1))
        C$ = Replace(B$, "CHR(", "")
        C$ = Replace(C$, ")", "")
        A$ = Replace(A$, B$, Chr(Val(C$)))
        p = InStr(A$, "CHR(")
Wend
Interpret = A$

End Function
Sub LoadDefaults()
Dim T As String

'get the defaults from the registry
UDSip = GetSetting(App.Title, "Settings", "IP", "127.0.0.1")
UDSport = Val(GetSetting(App.Title, "Settings", "Port", "1377"))
GenerateTimeStamps = CBool(GetSetting(App.Title, "Settings", "GenerateTimeStamps", "False"))
Reverse = CBool(GetSetting(App.Title, "Settings", "Reverse", "False"))
txtPollCmd = GetSetting(App.Title, "Settings", "PollCmd", "")
txtInit = GetSetting(App.Title, "Settings", "InitCmd", "")
txtStrip = GetSetting(App.Title, "Settings", "Strip", "")
For i = 0 To 2
        txtCmd(i).Text = GetSetting(App.Title, "settings", "txtCmd" + Trim(Str$(i)), "")
Next i
ComPortSettings = GetSetting(App.Title, "Settings", "ComPortSettings", "9600,N,8,1")
ComPort = Val(GetSetting(App.Title, "Settings", "ComPort", "1"))
vDataType = Val(GetSetting(App.Title, "Settings", "vDataType", "1"))

TZ = Val(GetSetting(App.Title, "Settings", "TZ", "0"))
UToffset = -1 * (TZ / 24)
UpdateOptionsDisplay 'show options
End Sub
Function GetRSDVMData() As String
'here is the function that retrieves a value from the meter.
'by using tenths of millivolts instead of volts or mv we can use the "Save as Integers" feature of SkyPipe
Dim RcvBuf As String
Dim V As Double
On Error GoTo MetexErr:
If BusyReadingMeter Then Exit Function
BusyReadingMeter = True
MSComm1.Output = "D" ' D is the command that the Radio Shack DVM expects before it generates a data string
LBLstatus = "Getting Voltage - Escape Aborts"
LBLstatus.Refresh
DoEvents
'wait for data from the meter or for a human to press escape
Do
    RcvBuf = RcvBuf + MSComm1.Input
    DoEvents
Loop Until EscapePressed Or Len(RcvBuf) >= 14 'the Radio Shack DVM returns a string 14 characters long

If EscapePressed Then
'we must have been stuck in a loop waiting for data from the meter and wanted out
       If Socket1.Count = 2 Then   ' if we are connected to SkyPipe break it
                If Socket1(1).Connected Then
                        SendMsgToSkyPipe "Data Collection Was manually aborted." ' tell SkyPipe what is going on
                        Socket1(1).Disconnect
                        DoEvents
                End If
       End If
       MsgBox " Meter reading aborted."
       BusyReadingMeter = False
       GetRSDVMData = "Aborted"
       EscapePressed = False
       Exit Function
End If

'strip out the voltage digits
V = Val(Mid$(RcvBuf, 4, 6))


If Mid$(RcvBuf, 12, 2) = "mV" Then
        V = V * 10
ElseIf Mid$(RcvBuf, 12, 2) = " V" Then
        V = V * 10000
End If
'at this point the data is in tenths of a millivolt format

LBLstatus = Str$(V / 10) + " millivolts"

'format the data so it fits the desired return type
If ReturnType = VoltsSingle Then
        GetRSDVMData = Format(V / 10000, "##0.0###")
ElseIf ReturnType = mVSingle Then
        GetRSDVMData = Format(V / 10, "#####0.0")
ElseIf ReturnType = mVinteger Then
        GetRSDVMData = Format(Int(V / 10), "#####0")
ElseIf ReturnType = mVx10integer Then
        GetRSDVMData = Format(Int(V), "#####0")
End If


GetOut:
On Error Resume Next
BusyReadingMeter = False
Exit Function

MetexErr:
'if something goes wrong we come here
MsgBox "There was an error retrieving data form the meter" + vbCrLf + Err.Description
GetRSDVMData = "Aborted"
Resume GetOut


End Function

Sub GetSendData()
'This is routine where data is pulled from your ADC or whatever source and sent to SkyPipe
'we use this routine when data is being POLLED by SkyPipe

Dim buf As String ' used to write data to SkyPipe
Dim TS As Double 'Timestamps are doubles
Dim D As String ' used here to hold the  data we are sending

If Socket1.Count < 2 Then Exit Sub  ' don't try to send data if not connected
If Socket1(1).Connected = False Then Exit Sub
'Call the function to get the data from the meter
'the data is returned as an string
If Started = False Then Exit Sub

 
D = GetRSDVMData
If D = "Aborted" Then Exit Sub ' the string Aborted is returned when something goes wrong while retrieving data
buf = "#0" + D + Chr(255)
Socket1(1).Write buf, Len(buf)
DoEvents

'data is not updated in the strip chart until one of the following codes (3000 or 3001) is sent to SkyPipe
'3000 is used if you are generating your own timestamps here in the UDS
'3001 tells SkyPipe to generate the timestamp for you when it receives this message
'Note that data from all channels is sent before the timestamp is sent

If GenerateTimeStamps Then
        TS = GetTimeStamp ' call your routine to generate a timestamp
        buf = "^^3000" + Str$(TS) + Chr(255)
        Socket1(1).Write buf, Len(buf)
Else
        'let SkyPipe genrate the timestamp
        buf = "^^3001" + Chr(255)
        Socket1(1).Write buf, Len(buf)
End If

End Sub
Function GetTimeStamp() As Double
'modify this routine to suit your needs
'timestamps are double values that represent a VB date
'see the VB help files for an explanation

GetTimeStamp = CalcTime

End Function

Sub UpdateOptionsDisplay()
' refreshes the current displayed parameters with values actually contained in the variables.
txtIP.Text = UDSip
txtPort.Text = Str$(UDSport)
If GenerateTimeStamps Then chkTimeStamps.Value = 1 Else chkTimeStamps.Value = 0
txtChannels = Str$(NumChannels)
txtComPort = Str$(ComPort)
txtSettings = ComPortSettings
txtTZ = Str$(TZ)
OptSampleType(vDataType).Value = True
chkReverse.Value = CInt(Reverse)

End Sub

Private Sub Cmd_Click(Index As Integer)
'UDSInit
A$ = Interpret(txtCmd(Index).Text)
If A$ = "" Then Exit Sub
If MSComm1.PortOpen = False Then MSComm1.PortOpen = True
MSComm1.Output = A$

End Sub

Private Sub cmdApply_Click()
GetParamsFromDisplay
End Sub

Private Sub cmdDisconnect_Click()
'manually disconnect from SkyPipe
If Socket1.Count = 2 Then
        If Socket1(1).Connected Then
                Socket1(1).Disconnect
        End If
End If

End Sub

Private Sub cmdGetDefaults_Click()
LoadDefaults
UpdateOptionsDisplay
End Sub

Private Sub cmdSave_Click()
GetParamsFromDisplay
SaveDefaults
End Sub



Private Sub Form_KeyPress(KeyAscii As Integer)
If KeyAscii = vbKeyEscape Then
        EscapePressed = True
End If
End Sub

Private Sub Form_Load()
On Error Resume Next
NumChannels = 1 'only one channel is available from the meter
LoadDefaults
GetParamsFromDisplay

End Sub

Private Sub MSComm1_OnComm()
If Unloading Then Exit Sub
Select Case MSComm1.CommEvent
   ' Handle each event or error by placing
   ' code below each case statement

   ' Errors
      'Case comEventBreak   ' A Break was received.
      Case comEventFrame   ' Framing Error
            LBLstatus = "Framing Error"
      Case comEventOverrun   ' Data Lost.
            LBLstatus = "Overrun Error"
      Case comEventRxOver   ' Receive buffer overflow.
            LBLstatus = "Receive buffer overflow"
      'Case comEventRxParity   ' Parity Error.
            
      'Case comEventTxFull   ' Transmit buffer full.
      'Case comEventDCB   ' Unexpected error retrieving DCB]

   ' Events
      'Case comEvCD   ' Change in the CD line.
      'Case comEvCTS   ' Change in the CTS line.
      'Case comEvDSR   ' Change in the DSR line.
      'Case comEvRing   ' Change in the Ring Indicator.
      Case comEvReceive   ' Received RThreshold # of
                        ' chars.
            If Started Then
               InBuf = InBuf + MSComm1.Input
                
            End If
      'Case comEvSend   ' There are SThreshold number of
                     ' characters in the transmit
                     ' buffer.
      'Case comEvEOF   ' An EOF charater was found in
                     ' the input stream
   End Select

End Sub

Private Sub OptSampleType_Click(Index As Integer)
vDataType = Index

End Sub

Private Sub Socket1_Accept(Index As Integer, SocketId As Integer)
'we are only accepting requests on the index=0 socket

If Index = 0 Then
        LBLstatus = "Connection Request Recieved"
        LBLstatus.Refresh
        'if we are already connected then disconnect from client (SkyPipe)
        If Socket1.Count = 2 Then
                 If Socket1(1).Connected Then Socket1(1).Disconnect
                 DoEvents
                 Unload Socket1(1)
        End If
        Load Socket1(1)
        'we use the same ip for the connection but take the next port above the listening port
        Socket1(1).Bind UDSip, UDSport + 1
        'Accept the connection using the SocketId pass from the listening socket
        Socket1(1).Accept = SocketId
        LBLstatus = "Connected"
End If


End Sub

Private Sub Socket1_Disconnect(Index As Integer)
If Socket1.Count = 2 Then
        If Socket1(1).Connected Then Socket1(1).Disconnect
        DoEvents 'always best to use DoEvents to give updates to socket a chance to change status
        Socket1(1).Cleanup
        Unload Socket1(1)
        'if you are running a timer for pushing your should disable it here so that you are not trying to send
        'data when not connected
        Timer1.Enabled = False

End If
LBLstatus = "Disconnected"
Started = False ' quit collecting data
End Sub

Private Sub Socket1_Read(Index As Integer, DataLength As Integer, IsUrgent As Integer)
'here is where we get requests and information from SkyPipe

Dim Tstrdata As String
Dim strdata As String
Dim buf As String 'used for sending back responses
Dim CmdStr As String 'four character command string from SkyPipe
Dim Param As String  'parameter passed with command from SkypPipe if any
Dim p As Integer 'place keeper for string manipulation

'You would need the following variables if you were reading the Sound Card from SkyPipe
Dim PeakL, PeakR As Long
Dim WavgL, WavgR As Double



'    On Error Resume Next
Socket1(1).Read strdata, DataLength

While InStr(strdata, Chr$(255)) > 1
    'strip out the command string
    Tstrdata = Left$(strdata, InStr(strdata, Chr$(255)) - 1)
    'this is what remains (if anything) in the buffer
    strdata = Right$(strdata, Len(strdata) - (Len(Tstrdata) + 1))
    
   
   If Len(Tstrdata) >= 4 Then ' all valid commands are 4 characters
         CmdStr = Left$(Tstrdata, 4)
         If Len(Tstrdata) > 4 Then Param = Trim(Right$(Tstrdata, Len(Tstrdata) - 4)) Else Param = ""
         Select Case CmdStr
                Case Is = "INIT" ' run any initialize routines you might have
                            LBLstatus = "Init Request Received"
                            LBLstatus.Refresh
                            UDSInit  'call the initialization routine
                Case Is = "POLL" 'SkyPipe expects polled data
                            'if you need to do something special for setting up polling do it here
                            LBLstatus = "Polling Request Received"
                            LBLstatus.Refresh
                            PollDataInit   'call routine that sets up the polling of data
                Case Is = "PUSH" 'SkyPipe expects data to be pushed by UDS
                            'if you need to set up something special for pushed data do it here
                            LBLstatus = "Push Request Received"
                            LBLstatus.Refresh
                            PushDataInit   'call the routine that sets up the pushing of data to SkyPipe
                Case Is = "GETC" 'request for the number of channels you will be using
                            LBLstatus = "Channel Request Received"
                            LBLstatus.Refresh
                            buf = "^^2013" + Trim(Str$(NumChannels)) + Chr(255) 'the last digit represents the number of channels - the NumChannels global variable
                            Socket1(1).Write buf, Len(buf) 'send the info to SkyPipe
                            DoEvents
                Case Is = "GETD" 'SkyPipe is requesting data - this is polling
                            GetSendData  ' call your routine to get your data and send it to SkyPipe
                            'if you want to generate your own timestamps in the UDS call the routine to do it
                Case Is = "STAT"
                            'now send a message saying the UDS is ready to stream data
                            buf = "^^1001" + Chr(255) '1001 is the code to SkyPipe that says lets we are ready
                            LBLstatus = "Status Request Received"
                            LBLstatus.Refresh
                            Socket1(1).Write buf, Len(buf)
                            DoEvents
                            'If you are going send your own timestamps then you should
                            'send a special timestamp using code 3002 that will tell
                            'SkyPipe where to begin the chart.
                            If GenerateTimeStamps Then
                                        buf = "^^3002" + Str$(GetTimeStamp) + Chr(255)
                                        LBLstatus = "Start Timestamp Sent"
                                        LBLstatus.Refresh
                                        Socket1(1).Write buf, Len(buf)
                            End If
                            Started = True
                Case Is = "PINH" ' the requested status of a parallel port pin is high
                
                Case Is = "PINL" ' the requested status of a parallel port pin is Low
                            
                Case Is = "PEAK" 'peak buffers for Sound card being returned
                            If Len(Param) > 0 Then
                                    p = InStr(Param, " ") 'is there a space?
                                    If p > 0 Then 'there must be data for left channel also
                                                PeakR = Val(Left$(Param, p - 1))
                                                PeakL = Val(Right$(Param, Len(Param) - p))
                                    Else
                                                PeakR = Val(Param)
                                                PeakL = 0
                                    End If
                                    'Call Routine here process the Peak sound card values..
                
                            End If
                Case Is = "WAVG" 'peak buffers for Sound card being returned
                            If Len(Param) > 0 Then
                                    p = InStr(Param, " ") 'is there a space?
                                    If p > 0 Then 'there must be data for left channel also
                                                WavgR = Val(Left$(Param, p - 1))
                                                WavgL = Val(Right$(Param, Len(Param) - p))
                                    Else
                                                WavgR = Val(Param)
                                                WavgL = 0
                                    End If
                                    'Call Routine here process the Averaged sound card values..
                            End If
          End Select
   End If

Wend


End Sub

Private Sub Timer1_Timer()
'This is part of the push data example
'when the timer event fires we will push data to SkyPipe

Dim buf As String ' used to write data to SkyPipe
Dim TS As Double 'Timestamps are doubles
Dim D As String 'just a value used meter data

If Socket1.Count = 2 Then ' the second socket must exist
            If Socket1(1).Connected Then 'it must also be connected
                    'capture the data from the meter
                     D = GetRSDVMData
                     If D = "Aborted" Then
                            Timer1.Enabled = False
                            Exit Sub ' the string Abotrted is returned when something goes wrong while retrieving data
                     End If
                     buf = "#" + Trim(Str(i)) + D + Chr(255)
                     Socket1(1).Write buf, Len(buf)

                    'data is not updated in the strip chart until one of the following codes (3000 or 3001) is sent to SkyPipe
                    '3000 is used if you are generating your own timestamps here in the UDS
                    '3001 tells SkyPipe to generate the timestamp for you when it receives this message
                    'Note that data from all channels is sent before the timestamp is sent

                    If GenerateTimeStamps Then
                                TS = GetTimeStamp ' call your routine to generate a timestamp
                                buf = "^^3000" + Str$(TS) + Chr(255)
                                Socket1(1).Write buf, Len(buf)
                    Else
                                'let SkyPipe genrate the timestamp
                                buf = "^^3001" + Chr(255)
                                Socket1(1).Write buf, Len(buf)
                    End If
        End If

End If


End Sub
